
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;  32
;  16   .
;
;
;
;
;**************************************************************************************************************
;  
;**************************************************************************************************************

.include 	"m32def.inc"		;  ATMega32


;==============================================================================================================
;   // RAM
;==============================================================================================================
;
;******************************************************************************
;  
;******************************************************************************

.def	Temp =R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			;   / 
.def	Temp6=R22			; 		
.def	Temp7=R23			; 		
.def	Temp8=R24			;
; .def	wiretemp =R25			;    1-Wire (      )
; .def 	wireres	 = R2			;    r0...r15  (      )			




;******************************************************************************
; 
;******************************************************************************


.dseg     ;  



;******************************************************************************
; 
;******************************************************************************


.equ	XTAL = 16000000				;  16 
.equ	baudrate = 9600				;  UART
.equ	bauddivider = XTAL/(16*baudrate)-1	;     UART


;==============================================================================================================
;   // FLASH // 
;==============================================================================================================

.cseg	


;******************************************************************************
;  
;******************************************************************************	
	

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
rjmp reset				;  				



.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    



	ldi Temp, low(RAMEND)		;  
	out SPL, Temp
	ldi Temp, high(RAMEND)
	out SPH, Temp




;******************************************************************************
;  
;******************************************************************************


;         
;     ,        
;        


;	ldi Temp,0b00000000		;   "A" (0-, 1-)
;	out DDRB,Temp			; 00000000 - "" 




;	ldi Temp,0b00100000		;   "D" (0-, 1-)
;	out DDRD,Temp			; 0000000 - "" 
					 
		
			

;	ldi Temp,0b00100000		;  _1   "D" (   )
;	out PortD,Temp			; 



				
;******************************************************************************
;   
;******************************************************************************





				
;******************************************************************************
;   UART
;******************************************************************************


;   (  UBBRx )

uart_init:	

	LDI R16, low(bauddivider)	;
	OUT UBRRL, R16			; UBRRL
	LDI R16, high(bauddivider)	;
	OUT UBRRH, R16			; UBRRH





;   UCSRA    - ( UCSRA )

	LDI R16,0
	OUT UCSRA, R16




;  , - .


	LDI R16, (1<<RXEN)|(1<<TXEN)|(0<<RXCIE)|(0<<TXCIE)|(0<<UDRIE)
	OUT UCSRB, R16	





;   - 8 ,    UCSRC,      URSEL

	LDI R16, (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1)
	OUT UCSRC, R16






;******************************************************************************
;   (     )
;******************************************************************************



;******************************************************************************
;  
;******************************************************************************			

RCALL	LCD_INIT			;   (  "LCD_INIT"     )


;******************************************************************************
;   
;******************************************************************************

;	sei				;   
	

;*******************************************************************************
;   *****************************************************************
;*******************************************************************************

main:

	Rcall uart_rcv			;    UART
					;   R16



	Rcall uart_snt			;    UART
					;   R16



	rcall printhex			;    

	rjmp main			; 



;*******************************************************************************
;   UART
;*******************************************************************************


;   

uart_snt:

	SBIS 	UCSRA,UDRE		;     
	RJMP	uart_snt 		;   -  UDRE
 
	OUT	UDR, R16		;   R16
	RET				; 




;*******************************************************************************
;   UART
;*******************************************************************************

;     UART

uart_rcv:	

	SBIS UCSRA, RXC			;    
	RJMP uart_rcv			;   
 
	IN R16, UDR			;   - .
	RET				; .   R16







;*******************************************************************************
;     16-   ( 2  )
;*******************************************************************************

;  16  
;    X (XH:XL)


printhex16: 


        mov r16 , XH
        rcall printhex
        mov r16 , XL
        rcall printhex
        ret 


;*******************************************************************************
;        Hex-
;*******************************************************************************

;     hex ,         
;  r16     


printhex: 
   
	push r16			 ;      (    )
	swap r16			 ;   ,      
	rcall printhex1			 ;       
	pop   r16			 ;    

printhex1:
    
	andi r16, 0x0f			 ;    ( )
	rcall lcd_char			 ;      
	ret   





;*******************************************************************************
;   HEX  BCD
;*******************************************************************************

;     R16



HEX_to_BCD:

	clr r17				;   help

HEX_to_BCD_l:

	subi r16,10			; temp = temp  10
	brcs HEX_to_BCD_2		; ,   
	inc r17				;  r17    
	rjmp HEX_to_BCD_l		;     

HEX_to_BCD_2:

	subi r16,-10			;     r16
	swap r17			;   
	or r16,r17			;      BCD

	ret



;*******************************************************************************
;  
;*******************************************************************************

.include "lcd5110rus.asm"		;   	





;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************







